#include <stdio.h>
#include <conio.h>
#include "..\MSViscon.h"

#define ESC 27

/* Fyller matrisen med blanktecken, som betyder tomma rutor */
void rensa(char p[3][3]) {
		int rad, kol;

		for (rad = 0; rad <= 2; rad++)
				for (kol = 0; kol <= 2; kol++)
						p[rad][kol] = ' ';
}

/* Returnerar 1 om en vinnare finns, annars 0 */
int kontrollera(char p[3][3]) {

}

/* Ritar upp brdet p skrmen */
void visa(char p[3][3]) {
		int rad, kol;
		char ram[7][14] = { "Ŀ",
												"		 		 		 ",
												"Ĵ",
												"		 		 		 ",
												"Ĵ",
												"		 		 		 ",
												"" };

		clrscr();

		/* Skriv ledtext */
		gotoxy(10, 5);
		printf("Flytta med piltangenterna och markera med RETURN!");


		/* rita ram med vre vnstra hrnet p rad 10 kolumn 30 */
		for (rad = 0; rad <= 6; rad++) {
				gotoxy(30, 10 + rad);
				for (kol = 0; kol <= 12; kol++)
						putchar(ram[rad][kol]);
		}

		/* rita markeringarna */
		for (rad = 0; rad < 3; rad++) {
				for (kol = 0; kol < 3; kol++) {
						gotoxy(30 + 4*kol + 2, 10 + 2*rad + 1);
						if (p[rad][kol] == 'x')
								printf("%c", 'x');
						else if (p[rad][kol] == 'o')
								printf("%c", 'o');
				}
		}
}

void markera(int d, char p[3][3]) {
		static int rad = 0, kol = 0; /* Behller vrdet mellan anropen */
		char ch;

		/* vlj utseende och startposition fr markr */
		setcursor(1, 100);
		if (d == 1)
				gotoxy(32 + 4*1, 11 + 2*1);
		else
				gotoxy(32 + 4*kol, 11 + 2*rad);

		/* flytta omkring med piltangenterna */
		while (1) {
				rad = (wherey() - 11) / 2;
				kol = (wherex() - 32) / 4;

				if (kbhit()) {
						ch = getch();
						if (ch == 0 || ch == -32)
								{
										ch = getch();
										if (ch ==  77 && wherex() < 40)
												gotoxy(wherex() + 4, wherey());
										else if (ch ==	75 && wherex() > 32)
												gotoxy(wherex() - 4, wherey());
										else if (ch ==	80 && wherey() < 15)
												gotoxy(wherex(), wherey() + 2);
										else if (ch ==	72 && wherey() > 11)
												gotoxy(wherex(), wherey() - 2);
		  
								}
						/* markera och avbryt om RETURN och ledig plats */
						else if ( ch == 13 && p[rad][kol] == ' ') {
								if (d % 2 == 0)
										p[rad][kol] = 'o';
								else
										p[rad][kol] = 'x';
								setcursor(0, 100);
								break;
						}
				}
		}
}

int main() {
		char spelplan[3][3];
		int drag, klart;

		do {
				rensa(spelplan);
				visa(spelplan);

				/* spela en omgng */
				klart = 0;
				for (drag = 1; drag <= 9 && !klart; drag++) {
						markera(drag, spelplan);
						visa(spelplan);

						/* kontrollera vinnare om 5 markeringar eller fler */
						if (drag >= 5)
								klart = kontrollera(spelplan);
				}

				/* skriv omgngens resultat */
				gotoxy(30, 20);
				if (!klart)
						printf("Remi!");
				else if (drag % 2 == 0)
						printf("x vinner!");
				else
						printf("o vinner!");

				/* ny omgng ? */
				gotoxy(15, 23);
				printf("Programmet konstruerat av Gunnar Joki.");
				gotoxy(15, 24);
				printf("Tryck tangent f\224r ny omg\206ng! ESC avslutar!");
		}
		while (getch() != ESC);

		return 0;
}
